{
  Autor: Michael Springwald
  
  Erstellt am Dienstag, 29.April.2008
  Updatest
  -----------------------------------------------------------------------
01- Mittwoch, 30.April.2008      -                                      -
  -----------------------------------------------------------------------
02-                              -                                      -
   -----------------------------------------------------------------------
03-                              -                                      -
  -----------------------------------------------------------------------
04-                              -                                      -
  -----------------------------------------------------------------------
05-                              -                                      -
  -----------------------------------------------------------------------
06-                              -                                      -
  -----------------------------------------------------------------------
07-                              -                                      -
  -----------------------------------------------------------------------
}

unit uPlutoEditor;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Controls, Graphics, LCLType,
  uPlutoTextBuffer,LMessages,StdCtrls,LCLProc,LCLIntf;

type

  { TPlutoEditor }
  TPlutoEditor = class(TCustomControl)
  private
  protected
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure WMVScroll(var Message: TLMVScroll); message LM_VScroll;
    procedure WMHScroll(var Message: TLMHScroll); message LM_HScroll;
    procedure WMSize(var Message: TLMSize); message LM_SIZE;

  public
    TextBuffer:TPlutoTextBuffer;
    FScrollBars: TScrollStyle;
    FScrollMaxX: Integer;
    FScrollMaxY: Integer;
    FScrollPagX: Integer;
    FScrollPagY: Integer;
    FScrollPosX: Integer;
    FScrollPosY: Integer;

    procedure UpdateScrollBars;

    procedure DoScrollBy(DeltaX, DeltaY: Integer); virtual;
    procedure DoScrollTo(PosX, PosY: Integer); virtual;

    procedure CreateParams(var Params: TCreateParams); override;
    constructor Create(AOwner: TComponent); override;
    procedure Test;
    destructor Destroy; override;
    procedure Paint; override;
    
  published

  end; // TPlutoEditor

implementation

{ TPlutoEditor }

procedure TPlutoEditor.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);

  if key = VK_LEFT then begin
    if TextBuffer.CaretInfo.CaretX-1 >=0 then begin
      TextBuffer.CaretInfo.CaretX:=TextBuffer.CaretInfo.CaretX-1;
      TextBuffer.DrawLine(TextBuffer.CaretInfo.CaretY);
    end;
  end; // VK_LEFT
  
  if key = VK_RIGHT then begin
    if TextBuffer.CaretInfo.CaretX+1<=Length(TextBuffer.Lines[TextBuffer.CaretInfo.CaretY]) then begin
      TextBuffer.CaretInfo.CaretX:=TextBuffer.CaretInfo.CaretX+1;
      TextBuffer.DrawLine(TextBuffer.CaretInfo.CaretY);
    end;
  end; // VK_RIGHT
  
  if key = VK_UP then begin
    if TextBuffer.CaretInfo.CaretY-1>=0 then begin
      if TextBuffer.CaretInfo.CaretY > -1 then
        TextBuffer.DrawLine(TextBuffer.CaretInfo.CaretY,False);

      TextBuffer.CaretInfo.CaretY:=TextBuffer.CaretInfo.CaretY-1;
      TextBuffer.DrawLine(TextBuffer.CaretInfo.CaretY);
    end;
  end; // VK_UP
  
  if key = VK_DOWN then begin
    if TextBuffer.CaretInfo.CaretY+1<=TextBuffer.Lines.Count-1 then begin
      if TextBuffer.CaretInfo.CaretY > -1 then
        TextBuffer.DrawLine(TextBuffer.CaretInfo.CaretY,False);

      TextBuffer.CaretInfo.CaretY:=TextBuffer.CaretInfo.CaretY+1;
      TextBuffer.DrawLine(TextBuffer.CaretInfo.CaretY);
    end;
  end; // VK_DOWN
end; // TPlutoEditor.KeyDown

procedure TPlutoEditor.WMVScroll(var Message: TLMVScroll);
var
  S: TScrollInfo;
begin
  inherited;
  case Message.ScrollCode of
    SB_LINEDOWN: DoScrollBy(0, -1);
    SB_LINEUP: DoScrollBy(0, 1);
    SB_PAGELEFT: DoScrollBy(0, -FScrollPagY);
    SB_PAGERIGHT: DoScrollBy(0,FScrollPagY);
    SB_THUMBTRACK,
    SB_THUMBPOSITION:
                begin
//                  writeln('TEST');
                    S.cbSize := SizeOf(S);
                    S.fMask := SIF_TRACKPOS;
                    GetScrollInfo(Handle, SB_Vert, S);
                    DoScrollTo(FScrollPosX, S.nTrackPos);
                end;
    SB_TOP: DoScrollTo(0, 0);
    SB_BOTTOM: DoScrollTo(FScrollMaxX, FScrollMaxY);
  else
      exit;
  end;
  Message.Result := 0;
end; // TPlutoEditor.WMVScroll

procedure TPlutoEditor.WMHScroll(var Message: TLMHScroll);
var
  S: TScrollInfo;
begin
  inherited;
  case Message.ScrollCode of
    SB_LINELEFT: DoScrollBy(-1, 0);
    SB_LINERIGHT: DoScrollBy(1, 0);
    SB_PAGELEFT: DoScrollBy(-FScrollPagX, 0);
    SB_PAGERIGHT: DoScrollBy(FScrollPagX, 0);
    SB_THUMBTRACK,
    SB_THUMBPOSITION:
                begin
                    S.cbSize := SizeOf(S);
                    S.fMask := SIF_TRACKPOS;
                    GetScrollInfo(Handle, SB_HORZ, S);
                    DoScrollTo(S.nTrackPos, FScrollPosY);
                end;
    SB_TOP: DoScrollTo(0, 0);
    SB_BOTTOM: DoScrollTo(FScrollMaxX, FScrollMaxY);
  else
      exit;
  end;
  Message.Result := 0;
end; // TPlutoEditor.WMHScroll

procedure TPlutoEditor.WMSize(var Message: TLMSize);
begin
  inherited;
  UpdateScrollBars;
end; // TPlutoEditor.WMSize

procedure TPlutoEditor.UpdateScrollBars;
var
  S: TScrollInfo;
begin
  FScrollPagX := ClientWidth div 5;
  FScrollPagY := ClientHeight div 5;
  if (HandleAllocated) then begin
    if (FScrollBars in [ssHorizontal, ssBoth]) then begin
        S.cbSize := SizeOf(S);
        S.fMask := SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL;
        S.nPos := FScrollPosX;
        S.nMin := 0;
        S.nMax := FScrollMaxX;
        if (FScrollPagX > 0) then
          inc(S.nMax, FScrollPagX - 1);
        S.nPage := FScrollPagX;
        SetScrollInfo(Handle, SB_HORZ, S, true);
    end;

    if (FScrollBars in [ssVertical, ssBoth]) then begin
        S.cbSize := SizeOf(S);
        S.fMask := SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL;
        S.nPos := FScrollPosY;
        S.nMin := 0;
        S.nMax := FScrollMaxY;
        if (FScrollPagY > 0) then
          inc(S.nMax, FScrollPagY - 1);
        S.nPage := FScrollPagY;
        SetScrollInfo(Handle, SB_Vert, S, true);
    end;
  end
  //else
//    writeln('OK');

end;

procedure TPlutoEditor.DoScrollBy(DeltaX, DeltaY: Integer);
begin
  DoScrollTo(FScrollPosX + DeltaX, FScrollPosY + DeltaY);

end;

procedure TPlutoEditor.DoScrollTo(PosX, PosY: Integer);
begin
  if (PosX <> FScrollPosX) or (PosY <> FScrollPosY) then begin
    FScrollPosX := PosX;
    FScrollPosY := PosY;
    UpdateScrollBars;
  end;
end;

procedure TPlutoEditor.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  case FScrollBars of
    ssHorizontal: Params.Style := Params.Style or WS_HSCROLL;
    ssVertical: Params.Style := Params.Style or WS_VSCROLL;
    ssBoth: Params.Style := Params.Style or WS_HSCROLL or WS_VSCROLL;
  end;
end; // // PlutoEditor.CreateParams

constructor TPlutoEditor.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  TextBuffer:=TPlutoTextBuffer.Create;
  TextBuffer.Canvas:=Canvas;

  FScrollMaxX:=800;
  FScrollMaxY:=500;

  FScrollPagX:=100;
  FScrollPagY:=10000;

  FScrollPosX:=0;
  FScrollPosY:=0;

end;

procedure TPlutoEditor.Test;
begin
  RecreateWnd(self);
end;

destructor TPlutoEditor.Destroy;
begin
  inherited Destroy;
end; // TPlutoEditor.Destroy

procedure TPlutoEditor.Paint;
begin
  TextBuffer.Width:=Width; TextBuffer.Height:=Height;
  TextBuffer.DrawText;
end; // TPlutoEditor.Paint

end.

