{
  Autor: Michael Springwald

  Erstellt am Dienstag, 29.April.2008
  Updatest
  -----------------------------------------------------------------------
01- Mittwoch, 30.Arpil.2008      -                                      -
  -----------------------------------------------------------------------
02-                              -                                      -
   -----------------------------------------------------------------------
03-                              -                                      -
  -----------------------------------------------------------------------
04-                              -                                      -
  -----------------------------------------------------------------------
05-                              -                                      -
  -----------------------------------------------------------------------
06-                              -                                      -
  -----------------------------------------------------------------------
07-                              -                                      -
  -----------------------------------------------------------------------
}

unit uPlutoTextBuffer;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics;

type

  { TPlutoCaretInfo }

  TPlutoCaretInfo = class
  private

  protected

  public
    // Die Spalte in der StringList wo sich der Cursor gerade befindet
    CaretX:Integer;
    // Die Zeile in der StringList wo sich der Cursor Gerade befindet
    CaretY:Integer;

    // Die Zeichnen Positon vom Cursor
    CaretPX:Integer;
    CaretPY:Integer;
    constructor Create;
    destructor Destroy; override;
  published

  end; // TPlutoCaretInfo

  { TPlutoTextItem }
  TPlutoTextItem = class
  private

  protected

  public
    py:Integer; // Die Genaue Pixel Position in der StringList
    sy:Integer; // Die Anzeige Position
    y:Integer;  // Die Zeile
    
    ph:Integer; // Die Höher der Zeile
    
    constructor Create;
    destructor Destroy; override;
  published

  end; // TPlutoTextItem
  
  { TPlutoTextBuffer }
  TPlutoTextBuffer = class
  private
    fLines: TStrings;
    function GetTexItem(index: Integer): TPlutoTextItem;
  protected

  public
    Canvas:TCanvas;
    Width,Height:Integer;
    CaretInfo:TPlutoCaretInfo;
    constructor Create;
    destructor Destroy; override;

    // Gibt die genau Pixel Position zurück
    function GetPX(const aIndex, aColumn:Integer):Integer;
    
    // DrawText zeichnet den Kompletten Text und ruft DrawLine auf
    procedure DrawText;

    //  DrawLine zeichnet die angaben Zeile neu
    procedure DrawLine(const aIndex:Integer; const aDrawCaret:Boolean = True);
    property TextItem[index:Integer]:TPlutoTextItem read GetTexItem;
    
    {
     Ermittelt die richtige Position im Text Buffer,
     abhänig von der Y Position des Vorgäners
    }
    function GetPY(const aIndex:Integer):Integer;
    
    // Fügt eine neue zeile hinzu
    procedure AddLine(const aLine:String; const aIndex:Integer = -1);
    
    {
      Um ein Text zu laden werden bestimmte Informationen benötig,
      die hier gesetzt werden. Also nicht die Lade Procedure
      der StringList verwenden sondern diese hier
    }
    procedure LoadFromFile(const aFileName:String);

  published
    {
      Im Moment verwende ich für den Text eine TStringList.
      Später soll das aus verschiedenen eine eigene Klasse
      werden.
    }

    property Lines:TStrings read fLines write FLines;
    

  end; // TPlutoTextBuffer
  
implementation

{ TPlutoTextBuffer }

function TPlutoTextBuffer.GetTexItem(index: Integer): TPlutoTextItem;
begin
  result:=(Lines.Objects[index] as TPlutoTextItem);
end; // TPlutoTextBuffer.GetTexItem

constructor TPlutoTextBuffer.Create;
begin
  inherited Create;
  fLines:=TStringList.Create;
  CaretInfo:=TPlutoCaretInfo.Create;
end; // TPlutoTextBuffer.Crea

destructor TPlutoTextBuffer.Destroy;
begin
  inherited Destroy;
end; // TPlutoTextBuffer.Destroy

function TPlutoTextBuffer.GetPX(const aIndex, aColumn: Integer): Integer;
var
  x,px:Integer;
  str:String;
begin
  px:=5;
  str:=Lines[aIndex];
  for x:=1 to Length(Lines[aIndex]) do begin
    if x >=aColumn then begin
      break;
    end
    else
      px:=px+Canvas.TextWidth(str[x]);
  end;
  result:=px;
end; // TPlutoTextBuffer.GetPX

procedure TPlutoTextBuffer.DrawText;
var
  i:integer;
begin
  Canvas.Brush.Style:=bsSolid;
  Canvas.Brush.Color:=clWhite;
  Canvas.Font.Color:=clBlack;
  Canvas.FillRect(0,0,Width,Height);
  
  for i:=0 to Lines.Count-1 do DrawLine(i, i = CaretInfo.CaretY);
end; // TPlutoTextBuffer.DrawText

procedure TPlutoTextBuffer.DrawLine(const aIndex: Integer; const aDrawCaret:Boolean = True);
begin
  TextItem[aIndex].ph:=Canvas.TextHeight(Lines[aIndex])+5;
  TextItem[aIndex].py:=GetPY(aIndex);
  
  Canvas.FillRect(5,TextItem[aIndex].py,5+Canvas.TextWidth(Lines[aIndex])+10,TextItem[aIndex].py+TextItem[aIndex].ph);
  
  if aDrawCaret then begin
    CaretInfo.CaretPX:=GetPX(aIndex, CaretInfo.CaretX);
    CaretInfo.CaretPY:=TextItem[aIndex].py;

    Canvas.Pen.Color:=clBlue;
    Canvas.MoveTo(CaretInfo.CaretPX, CaretInfo.CaretPY);
    Canvas.LineTo(CaretInfo.CaretPX, CaretInfo.CaretPY+TextItem[aIndex].ph);
  end;
  
  Canvas.TextOut(5,TextItem[aIndex].py,Lines[aIndex]);
end; // TPlutoTextBuffer.DrawLine

function TPlutoTextBuffer.GetPY(const aIndex: Integer): Integer;
begin
  if aIndex <= 0 then
    result:=2
  else begin
    result:=TextItem[aIndex-1].py+TextItem[aIndex-1].ph;
  end;
end; // TPlutoTextBuffer.GetPY

procedure TPlutoTextBuffer.AddLine(const aLine:string; const aIndex: Integer = -1);
var
  aTextItem:TPlutoTextItem;
begin
  aTextItem:=TPlutoTextItem.Create;
  if aIndex = -1 then
    Lines.AddObject(aLine,aTextItem)
  else
    Lines.InsertObject(aIndex,aLine,aTextItem);
end; // TPlutoTextBuffer.AddLine

procedure TPlutoTextBuffer.LoadFromFile(const aFileName: String);
var
  i:Integer;
  TextList:TStringList;
begin
  TextList:=TStringList.Create;
  TextList.LoadFromFile(aFileName);
  for i:=0 to TextList.Count-1 do begin
    AddLine(TextList[i],-1);
  end; // for i
end; // TPlutoTextBuffer.LoadFromFile

{ TPlutoTextItem }

constructor TPlutoTextItem.Create;
begin
  inherited Create;
end; // TPlutoTextItem.Create

destructor TPlutoTextItem.Destroy;
begin
  inherited Destroy;
  py:=-1; sy:=-1; y:=-1;
end; // TPlutoTextItem.Destroy

{ TPlutoCaretInfo }

constructor TPlutoCaretInfo.Create;
begin
  inherited Create;
  CaretPX:=0; CaretPY:=0; CaretX:=0; CaretY:=0;
end;

destructor TPlutoCaretInfo.Destroy;
begin
  inherited Destroy;
end;

end.

